MyNPC_speakColor = { r = 1.0, g = 1.0, b = 0.62 }
MyNPC_emoteColor = { r = 1, g = 0.5, b = 0.25 }

function MyNPC_OnLoad()
	DEFAULT_CHAT_FRAME:AddMessage( MyNPC_ONLOAD_MESSAGE )
	SlashCmdList["MyNPC"] = MyNPC_command
	SLASH_MyNPC1 = "/mn"
end

function MyNPC_command(cmd, adv)
	if MyNPCWords[MyNPC_adventure]==nil then
		MyNPCWords[MyNPC_adventure] = {}
	end
	if MyNPCZones[MyNPC_adventure]==nil then
		MyNPCZones[MyNPC_adventure] = {}
	end

	if cmd == "" then
		MyNPCFrames_Toggle(6)
	end
	if cmd == "create" then
		MyNPCFrames_Toggle(7)
	end
	if cmd == "adv" then
		DEFAULT_CHAT_FRAME:AddMessage("*** "..MyNPC_adventure.." ***")
	end
	local whereAdv = strfind(cmd, "adv ")
	if whereAdv == 1 then
		local cmd2 = strtrim(strsub(cmd, 5))
		if cmd2 ~= "" then
			MyNPC_adventure = cmd2
			if MyNPCWords[MyNPC_adventure]==nil then
				MyNPCWords[MyNPC_adventure] = {}
			end
			if MyNPCZones[MyNPC_adventure]==nil then
				MyNPCZones[MyNPC_adventure] = {}
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage("*** "..MyNPC_adventure.." ***")
	end
end

function MyNPC_insertNPC(target, keywords, answers)
	keywords = strtrim(keywords)
	if MyNPCWords[MyNPC_adventure][target]==nil then
		MyNPCWords[MyNPC_adventure][target] = {}
	end
	local tableTriggers = {}
	while keywords~="" do
		local position = strfind(keywords, ":")
		if position~=nil then
			local word = strtrim(strsub(keywords, 0, position-1))
			if word~="" then
				tinsert(tableTriggers, strtrim(word))
			end
			keywords = strtrim(strsub(keywords, position+1))
		else
			tinsert(tableTriggers, strtrim(keywords))
			keywords = ""
		end
	end
	local tableAnswers = {
		Triggers = tableTriggers,
		[0] = answers
	}
	tinsert(MyNPCWords[MyNPC_adventure][target], tableAnswers)
end

function MyNPC_insertZone(zoneName, answers)
	MyNPCZones[MyNPC_adventure][zoneName] = answers
end

function MyNPC_talk(text)
	if(UnitName("target")~=nil) then
		local nom = ""
		local color = MyNPC_emoteColor
		if(text~=MyNPC_OBSERVE and text~=MyNPC_ENVIRON) then
			color = MyNPC_speakColor
			nom = UnitName("target").." "..MyNPC_ISSAYING.." "
		end
		if MyNPCWords[MyNPC_adventure][UnitName("target")] ~= nil then
			for key,value in pairs(MyNPCWords[MyNPC_adventure][UnitName("target")]) do
				for i,word in pairs(value.Triggers) do
					if string.find(string.lower(text),string.lower(word)) ~= nil then
						--DEFAULT_CHAT_FRAME:AddMessage( nom..string.gsub(string.gsub(value[0], "!!! TRICHEUR !!!", "e"), "'player'", UnitName("player")), color.r, color.g, color.b )
						DEFAULT_CHAT_FRAME:AddMessage( nom..string.gsub(value[0], "'player'", UnitName("player")), color.r, color.g, color.b )
						return 0
					end
				end
			end
		end
		for key,value in pairs(Words[UnitFactionGroup("player")]) do
			for i,word in pairs(value.Triggers) do
				if string.find(string.lower(text),string.lower(word)) ~= nil then
					DEFAULT_CHAT_FRAME:AddMessage( nom..value[math.floor(math.random()*value.Count)], color.r, color.g, color.b )
					return 0
				end
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage( UnitName("target").." "..MyNPC_ISSAYING.." "..Default[UnitFactionGroup("player")][math.floor(math.random()*Default[UnitFactionGroup("player")].Count)], color.r, color.g, color.b )
	else
		local color = MyNPC_emoteColor
		local ZoneNames = { GetMapZones(GetCurrentMapContinent()) } 
		local CurrentZoneName = ZoneNames[GetCurrentMapZone()]
		
		if MyNPCZones[MyNPC_adventure][CurrentZoneName] ~= nil then
			--DEFAULT_CHAT_FRAME:AddMessage( string.gsub(value[0], "!!! TRICHEUR !!!", "e"), color.r, color.g, color.b )
			DEFAULT_CHAT_FRAME:AddMessage( MyNPCZones[MyNPC_adventure][CurrentZoneName], color.r, color.g, color.b )
			return 0
		else
			DEFAULT_CHAT_FRAME:AddMessage( "Tout est calme en "..CurrentZoneName, color.r, color.g, color.b )
		end
	end
end

function MyNPCFrames_Toggle(num)
	local frame = getglobal("FaraFrames" .. num)
	if (frame) then
		if( frame:IsVisible() ) then
			frame:Hide()
		else
			frame:Show()
		end
	end
end

function MyNPCEdit_Process()
	if strtrim(this:GetText()) ~= "" then
		DEFAULT_CHAT_FRAME:AddMessage( UnitName("player").." "..MyNPC_ISSAYING.." "..this:GetText(), MyNPC_speakColor.r, MyNPC_speakColor.g, MyNPC_speakColor.b )
		if(UnitName("target")~=nil) then
			MyNPC_talk(this:GetText())
		end
		this:SetText("")
	end
end

function MyNPCButton_Process()
	if(UnitName("target")~=nil) then
		DEFAULT_CHAT_FRAME:AddMessage( MyNPC_ISOBSERVING.." "..UnitName("target")..".", MyNPC_emoteColor.r, MyNPC_emoteColor.g, MyNPC_emoteColor.b )
		MyNPC_talk(this:GetText())
	else
		DEFAULT_CHAT_FRAME:AddMessage( MyNPC_ISOBSERVINGZONE, MyNPC_emoteColor.r, MyNPC_emoteColor.g, MyNPC_emoteColor.b )
		MyNPC_talk(MyNPC_ENVIRON)
	end
end

function MyNPCButtonCreate_Process()
	local target = UnitName("target")
	local keywords = FaraFrames7_InputBoxKeywords:GetText()
	local answers = FaraFrames7_InputBoxAnswers:GetText()
	if answers~="" then
		if(UnitName("target")~=nil) then
			if keywords~="" then
				DEFAULT_CHAT_FRAME:AddMessage( "->- "..target.." "..MyNPC_ISSAYING.." ".. answers.." (".. keywords..")", MyNPC_speakColor.r, MyNPC_speakColor.g, MyNPC_speakColor.b )
			else
				DEFAULT_CHAT_FRAME:AddMessage( "->- "..target.." -> ".. answers, MyNPC_emoteColor.r, MyNPC_emoteColor.g, MyNPC_emoteColor.b )
				keywords = MyNPC_OBSERVE
			end
			MyNPC_insertNPC(target, keywords, answers)
		else
			local ZoneNames = { GetMapZones(GetCurrentMapContinent()) } 
			local CurrentZoneName = ZoneNames[GetCurrentMapZone()]
			DEFAULT_CHAT_FRAME:AddMessage( "->- "..CurrentZoneName.." -> "..answers, MyNPC_emoteColor.r, MyNPC_emoteColor.g, MyNPC_emoteColor.b )
			MyNPC_insertZone(CurrentZoneName, answers)
		end
		FaraFrames7_InputBoxKeywords:SetText("")
		FaraFrames7_InputBoxAnswers:SetText("")
	end
end